F// AddBrainCellDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BrainCellMonitor.h"
#include "AddBrainCellDlg.h"
#include <Creatures/Brain.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddBrainCellDlg dialog


CAddBrainCellDlg::CAddBrainCellDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAddBrainCellDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddBrainCellDlg)
	fCellEdit = 0;
	fDendriteEdit = 0;
	fLobeEdit = 0;
	fDescriptionEdit = _T("");
	//}}AFX_DATA_INIT
}


void CAddBrainCellDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddBrainCellDlg)
	DDX_Control(pDX, IDC_DESCRIPTION_EDIT, fDescriptionWindow);
	DDX_Control(pDX, IDC_LOBE_DESC_EDIT, fLobeDescriptionWindow);
	DDX_Control(pDX, IDC_DENDRITE_DESC_EDIT, fDendriteDescriptionWindow);
	DDX_Control(pDX, IDC_CELL_DESC_EDIT, fCellDescriptionWindow);
	DDX_Control(pDX, IDC_LOBE_EDIT, fLobeEditWindow);
	DDX_Control(pDX, IDC_DENDRITE_EDIT, fDendriteEditWindow);
	DDX_Control(pDX, IDC_CELL_EDIT, fCellEditWindow);
	DDX_Control(pDX, IDC_LOBE_SPIN, fLobeSpin);
	DDX_Control(pDX, IDC_DENDRITE_SPIN, fDendriteSpin);
	DDX_Control(pDX, IDC_CELL_SPIN, fCellSpin);
	DDX_Text(pDX, IDC_CELL_EDIT, fCellEdit);
	DDV_MinMaxUInt(pDX, fCellEdit, 0, 9999);
	DDX_Text(pDX, IDC_DENDRITE_EDIT, fDendriteEdit);
	DDV_MinMaxUInt(pDX, fDendriteEdit, 0, 1);
	DDX_Text(pDX, IDC_LOBE_EDIT, fLobeEdit);
	DDV_MinMaxUInt(pDX, fLobeEdit, 0, 99);
	DDX_Text(pDX, IDC_DESCRIPTION_EDIT, fDescriptionEdit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddBrainCellDlg, CDialog)
	//{{AFX_MSG_MAP(CAddBrainCellDlg)
	ON_EN_CHANGE(IDC_DENDRITE_EDIT, OnChangeDendriteEdit)
	ON_EN_CHANGE(IDC_CELL_EDIT, OnChangeCellEdit)
	ON_EN_CHANGE(IDC_LOBE_EDIT, OnChangeLobeEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddBrainCellDlg message handlers

BOOL CAddBrainCellDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	fLobeSpin.SetRange(0, 99);
	fCellSpin.SetRange(0, 9999);
	fDendriteSpin.SetRange(0, 1);
	fLobeDescriptionWindow.SetWindowText("Perception lobe");
	fCellDescriptionWindow.SetWindowText("Cell number 0");
	fDendriteDescriptionWindow.SetWindowText("Dendrite type 0");
	fDescriptionWindow.SetWindowText("0-0-0");
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAddBrainCellDlg::OnChangeDendriteEdit() 
{
	// TODO: Add your control notification handler code here
	if(IsWindow(*this) && IsWindow(fDendriteEditWindow))
	{
		CString text;
		fDendriteEditWindow.GetWindowText(text);
		CString desc;
		desc.Format("Dendrite type %d", atoi(text));
		fDendriteDescriptionWindow.SetWindowText(desc);
		UpdateDescription();
	}
}

void CAddBrainCellDlg::OnChangeCellEdit() 
{
	// TODO: Add your control notification handler code here
	if(IsWindow(*this) && IsWindow(fLobeEditWindow))
	{
		CString text;
		fLobeEditWindow.GetWindowText(text);
		unsigned int lobeEdit = atoi(text);

		switch(lobeEdit)
		{
		case 1:	// Drive lobe
			{
				DriveLobe lobe;
				UpdateCellDescription(&lobe);
			}
			break;

		case 2:
			{
				StimulusSourceLobe lobe;
				UpdateCellDescription(&lobe);
			}
			break;
				
		case 3:
			{
				VerbLobe lobe;
				UpdateCellDescription(&lobe);
			}
			break;

		case 4:
			{
				NounLobe lobe;
				UpdateCellDescription(&lobe);
			}
			break;

		case 5:
			{
				SensoryLobe lobe;
				UpdateCellDescription(&lobe);
			}
			break;

		case 6:
			{
				DecisionLobe lobe;
				UpdateCellDescription(&lobe);
			}
			break;

		case 7:
			{
				AttentionLobe lobe;
				UpdateCellDescription(&lobe);
			}
			break;

		default:
			{
				UpdateCellDescription(0);
			}
			break;
		}

		UpdateDescription();
	}
}

void CAddBrainCellDlg::OnChangeLobeEdit() 
{
	// TODO: Add your control notification handler code here
	static char const* description[] =
	{
		"Perception lobe",
		"Drive lobe",
		"Source lobe",
		"Verb lobe",
		"Noun lobe",
		"General Sense lobe",
		"Decision lobe",
		"Attention lobe",
		"Concept lobe"
	};
	static const int number = sizeof(description) / sizeof(description[0]);

	if(IsWindow(*this) && IsWindow(fLobeEditWindow))
	{
		CString text;
		fLobeEditWindow.GetWindowText(text);
		unsigned int lobeEdit = atoi(text);
		CString desc;

		if(lobeEdit >= number)
		{
			desc.Format("Lobe number %d", lobeEdit);
		}
		else
		{
			desc = description[lobeEdit];
		}
		fLobeDescriptionWindow.SetWindowText(desc);

		UpdateDescription();
		OnChangeCellEdit();
	}
}

void CAddBrainCellDlg::UpdateCellDescription(Lobe* lobe)
{
	if(IsWindow(*this) && IsWindow(fCellEditWindow))
	{
		CString text;
		fCellEditWindow.GetWindowText(text);
		unsigned int cellEdit = atoi(text);
		CString desc;
		if(lobe == 0 || cellEdit >= lobe->getNumberOfCells())
		{
			desc.Format("Cell number %d", cellEdit);
		}
		else
		{
			desc = lobe->getCellDescription(cellEdit).c_str();
		}
		fCellDescriptionWindow.SetWindowText(desc);
	}
}

void CAddBrainCellDlg::UpdateDescription()
{
	if(IsWindow(*this) && 
		IsWindow(fLobeEditWindow) &&
		IsWindow(fCellEditWindow) &&
		IsWindow(fDendriteEditWindow))
	{
		CString text;
		fLobeEditWindow.GetWindowText(text);
		unsigned int lobeEdit = atoi(text);
		fCellEditWindow.GetWindowText(text);
		unsigned int cellEdit = atoi(text);
		fDendriteEditWindow.GetWindowText(text);
		unsigned int dendriteEdit = atoi(text);
		CString desc;
		desc.Format("%d-%d-%d", 
			lobeEdit,
			cellEdit,
			dendriteEdit);
		fDescriptionWindow.SetWindowText(desc);
	}
}
