// BrainCellMonitorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BrainCellMonitor.h"
#include "BrainCellMonitorDlg.h"
#include "AddBrainCellDlg.h"
#include <sstream>
#include <Creatures/Brain.h>
#include <cassert>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBrainCellMonitorDlg dialog

CBrainCellMonitorDlg::CBrainCellMonitorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBrainCellMonitorDlg::IDD, pParent),
	fSession(0),
	fTimerHandle(0),
	fLobe(new CompositeLobe())
{
	//{{AFX_DATA_INIT(CBrainCellMonitorDlg)
	fCaosEdit = _T("");
	fResultEdit = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CBrainCellMonitorDlg::~CBrainCellMonitorDlg()
{
	delete fSession;
	delete fLobe;
}

void CBrainCellMonitorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBrainCellMonitorDlg)
	DDX_Control(pDX, IDOK, fCloseButton);
	DDX_Control(pDX, IDC_REMOVE_BUTTON, fRemoveButton);
	DDX_Control(pDX, IDC_EXECUTE_BUTTON, fExecuteButton);
	DDX_Control(pDX, IDC_DISCONNECT_BUTTON, fDisconnectButton);
	DDX_Control(pDX, IDC_CONNECT_BUTTON, fConnectButton);
	DDX_Control(pDX, IDC_BRAINCELL_LIST, fBrainCellList);
	DDX_Control(pDX, IDC_ADD_BUTTON, fAddButton);
	DDX_Text(pDX, IDC_CAOS_EDIT, fCaosEdit);
	DDX_Text(pDX, IDC_RESULT_EDIT, fResultEdit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBrainCellMonitorDlg, CDialog)
	//{{AFX_MSG_MAP(CBrainCellMonitorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CONNECT_BUTTON, OnConnectButton)
	ON_BN_CLICKED(IDC_DISCONNECT_BUTTON, OnDisconnectButton)
	ON_BN_CLICKED(IDC_EXECUTE_BUTTON, OnExecuteButton)
	ON_BN_CLICKED(IDC_ADD_BUTTON, OnAddButton)
	ON_LBN_SELCHANGE(IDC_BRAINCELL_LIST, OnSelchangeBraincellList)
	ON_BN_CLICKED(IDC_REMOVE_BUTTON, OnRemoveButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBrainCellMonitorDlg message handlers

BOOL CBrainCellMonitorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	ResetButtons();
	fCaosEdit = "inst,trig 3 0 255,endm";
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBrainCellMonitorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBrainCellMonitorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBrainCellMonitorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBrainCellMonitorDlg::ResetButtons()
{ 
	if(fSession != 0) // we are connected
	{
		fConnectButton.EnableWindow(FALSE);
		fDisconnectButton.EnableWindow(TRUE);
		fExecuteButton.EnableWindow(TRUE);
		fCloseButton.EnableWindow(FALSE);
	}
	else // we are disconnected
	{
		fConnectButton.EnableWindow(TRUE);
		fDisconnectButton.EnableWindow(FALSE);
		fExecuteButton.EnableWindow(FALSE);
		fCloseButton.EnableWindow(TRUE);
	}

	// Disable remove button if there is no selected item
	fRemoveButton.EnableWindow(fBrainCellList.GetCurSel() != LB_ERR);
}

void CBrainCellMonitorDlg::OnConnectButton() 
{
	// TODO: Add your control notification handler code here
	assert(fSession == 0);

	try
	{
		fSession = new Creatures::Session();
		// As a test, get the creatures name and display it
		std::string name = fSession->executeMacro("inst,dde: getb cnam,endm");
		std::string title = "BrainCellMonitor - " + name; 
		SetWindowText(title.c_str());
		ResetButtons();
		StartTimer();	
	}
	catch(Creatures::DDEException&)
	{ 
		MessageBox("An error occurred trying to connect to Creatures.\nPlease ensure that Creatures is running and a norn is selected.",
			"Unable to connect");
	}
}

void CBrainCellMonitorDlg::OnDisconnectButton() 
{
	// TODO: Add your control notification handler code here
	StopTimer();
	delete fSession;
	fSession = 0;
	ResetButtons();
	SetWindowText("BrainCellMonitor");
}

void CBrainCellMonitorDlg::StartTimer()
{
	if(fTimerHandle != 0)
		StopTimer();

	fTimerHandle = SetTimer(1, 100, 0);
	if(fTimerHandle == 0)
	{
		MessageBox("Unable to start timer");
	}

}

void CBrainCellMonitorDlg::StopTimer()
{
	if(fTimerHandle != 0)
	{
		if(!KillTimer(1))
		{
			MessageBox("Unable to stop timer");
		}
		fTimerHandle = 0;
	}
}

void CBrainCellMonitorDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	UpdateData(TRUE);

	try
	{
		StopTimer();

		if(!fMacroToExecute.empty())
		{
			fResultEdit = fSession->executeMacro(fMacroToExecute.c_str());
			fMacroToExecute = "";
		}

		if(fLobe->getNumberOfCells() > 0)
		{
			std::string result = fSession->executeMacro(fLobe->getMacroCommand().c_str());
//			logger << result << std::endl;

			// The result of the macro call is parsed into a vector
			Lobe::CellVector all_data = fLobe->parseCellData(result);

			// Extract data from result
			int currentSelection = fBrainCellList.GetCurSel();
			fBrainCellList.ResetContent();
			if(all_data.empty())
			{
				fBrainCellList.AddString("Nothing");
			}
			Lobe::CellVector::iterator first = all_data.begin();
			Lobe::CellVector::iterator last = all_data.end();
			while(first != last)
			{
				LobeData data = (*first);

				std::ostringstream stream;
				stream << fLobe->getCellDescription(data.fCell)
					   << " ("
					   << data.getOutput() << "/" 
					   << data.getState() << "/"
					   << data.getNumberOfDendrites() << "/"
					   << data.getTotalSusceptability() << "/"
					   << data.getTotalSTW() << "/"
					   << data.getTotalLTW() << "/"
					   << data.getTotalStrength() 
					   << ")"
					   << std::ends;
				fBrainCellList.AddString(stream.str().c_str());	
				first++;
			}
			if(currentSelection != LB_ERR)
			{
				fBrainCellList.SetCurSel(currentSelection);
			}
		}

		StartTimer();
	}
	catch(Creatures::DDEException&)
	{
		MessageBox("DDE Exception");
		OnDisconnectButton();
	}
	
	CDialog::OnTimer(nIDEvent);

	UpdateData(FALSE);
}


void CBrainCellMonitorDlg::OnExecuteButton() 
{
	// TODO: Add your control notification handler code here
	StopTimer();
	UpdateData(TRUE);
	fMacroToExecute = fCaosEdit;
	StartTimer();	
}


void CBrainCellMonitorDlg::OnAddButton() 
{
	// TODO: Add your control notification handler code here
	if(fSession != 0) StopTimer();
	CAddBrainCellDlg dialog;
	if(dialog.DoModal() == IDOK)
	{
		fLobe->addCell(dialog.fLobeEdit,
			dialog.fCellEdit,
			dialog.fDendriteEdit,
			std::string((char const*)dialog.fDescriptionEdit));
	}
	if(fSession != 0)  StartTimer();
}

void CBrainCellMonitorDlg::OnSelchangeBraincellList() 
{
	// TODO: Add your control notification handler code here
	fRemoveButton.EnableWindow(fBrainCellList.GetCurSel() != LB_ERR);	
}

void CBrainCellMonitorDlg::OnRemoveButton() 
{
	// TODO: Add your control notification handler code here
	if(fSession != 0) StopTimer();
	fLobe->removeCell(fBrainCellList.GetCurSel());	
	ResetButtons();
	if(fSession != 0)  StartTimer();
}
