// BrainCellMonitorDlg.h : header file
//
#include <Creatures/CreaturesConversation.h>
#include <string>

struct CompositeLobe;

/////////////////////////////////////////////////////////////////////////////
// CBrainCellMonitorDlg dialog

class CBrainCellMonitorDlg : public CDialog
{
// Construction
public:
	CBrainCellMonitorDlg(CWnd* pParent = NULL);	// standard constructor
	~CBrainCellMonitorDlg();

	Creatures::Session* fSession;
	UINT fTimerHandle;
	std::string fMacroToExecute;
	CompositeLobe* fLobe;

	void ResetButtons();
	void StartTimer();
	void StopTimer();


// Dialog Data
	//{{AFX_DATA(CBrainCellMonitorDlg)
	enum { IDD = IDD_BRAINCELLMONITOR_DIALOG };
	CButton	fCloseButton;
	CButton	fRemoveButton;
	CButton	fExecuteButton;
	CButton	fDisconnectButton;
	CButton	fConnectButton;
	CListBox	fBrainCellList;
	CButton	fAddButton;
	CString	fCaosEdit;
	CString	fResultEdit;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBrainCellMonitorDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CBrainCellMonitorDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnConnectButton();
	afx_msg void OnDisconnectButton();
	afx_msg void OnExecuteButton();
	afx_msg void OnAddButton();
	afx_msg void OnSelchangeBraincellList();
	afx_msg void OnRemoveButton();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
